#***********************************************************************
# Z88MTINA.PL - ein Perl-Konverter von Z88V14OS nach Z88V13
# - anyway, not very perlish -
# folgende Subroutinen:
# G1I188: Checken 1.Zeile Z88I1.TXT               Bei ~  445.
# G2I188: Checken Knoten Z88I1.TXT                Bei ~  534.
# G3I188: Checken Koinzidenz Z88I1.TXT            Bei ~  597.
# GXI288: Checken Z88I2.                          Bei ~  801.
# GXI588: Checken Z88I5.TXT.                      Bei ~  968.
# GMAN88: Checken Z88MAN.TXT.                     Bei ~ 1154.
# GMAT88: Checken Z88MAT.TXT.                     Bei ~ 1223.
# GELP88: Checken Z88ELP.TXT.                     Bei ~ 1383.
# GINT88: Checken Z88INT.TXT.                     Bei ~ 1589.
## 15.4.14 Rieg
#***********************************************************************

#***********************************************************************
# Hauptprogramm
#***********************************************************************
{

#-----------------------------------------------------------------------
# Kommandozeile auswerten
#-----------------------------------------------------------------------
$LANG= 2;  # englisch als default

chomp($ARGV[0]);

if(@ARGV != 1) 
  { 
  print "use: perl Z88MTINA.pl -german|-english\n";
  exit;
  }

if(!( ($ARGV[0] eq '-german' || $ARGV[0] eq '-english') ))
  { 
  print "use: perl Z88MTINA.pl -german|-english\n";
  exit;
  }

if($ARGV[0] eq '-german') { $LANG= 1; }
if($ARGV[0] eq '-english'){ $LANG= 2; }

print "\n                *****   ***    ***\n";
print "                   *   *   *  *   *\n";
print "                  *     ***    ***\n";
print "                 *     *   *  *   *\n";
print "                *****   ***    ***\n";

if($LANG == 1) 
  { 
  print " von Univ.Prof.Dr.-Ing. FRANK RIEG (C),2014 Z88TINA\n"; 
  print " Z88MTINA.PL: ein Z88-Datei-Konverter von Z88V14OS nach Z88TINA\n";
  print " fuer die Elementtypen Nr. 2,4,5,9,13,14,15,18\n\n";
  }

if($LANG == 2) 
  { 
  print " by Prof. FRANK RIEG (C), Germany 2014 Z88TINA\n"; 
  print " Z88MTINA.PL: a Z88 File Converter from Z88V14OS to Z88TINA\n";
  print " for element types no. 2,4,5,9,13,14,15,18\n\n";
  }

#-----------------------------------------------------------------------
# der Prompt
#-----------------------------------------------------------------------
if($LANG == 1) 
  { print "Start Z88MTINA.PL, checken und konvertieren von Z88V14OS- in Z88Tina-Format \n";}
if($LANG == 2) 
  { print "Start Z88MTINA.PL, checking and converting from Z88V14OS to Z88Tina format\n";}

Lomore:;

if($LANG == 1)
  {
  print " 1  -->  Checken und Schreiben\n";
  print " 9  -->  Beende Z88MTINA\n\n";
  print " Ihre Wahl: ";
  }

if($LANG == 2)
  {
  print " 1  -->  Check + Write\n";
  print " 9  -->  Quit Z88MTINA\n\n";
  print " Your choice: ";
  }

chomp($zeile = <STDIN>);

if(!($zeile eq '1' || $zeile eq '9'))
  { goto Lomore; }

$CHOICE= $zeile;

#-----------------------------------------------------------------------
# Eingabedateien fuer den ersten grundlegenden Check oeffnen
#-----------------------------------------------------------------------
#=======================================================================
# OpenSource-Mode:
#=======================================================================
if($CHOICE == 1)  
  {
  if($LANG == 1)
    {
    # Eingabefiles Z88V14OS
    open I1 , "< z88i1.txt"
    or die "kann z88i1.txt nicht oeffnen...Stop!\n";
    open MAN, "< z88man.txt"
    or die "kann z88man.txt nicht oeffnen...Stop!\n";
    open MAT, "< z88mat.txt"
    or die "kann z88mat.txt nicht oeffnen...Stop!\n";
    open INT, "< z88int.txt"
    or die "kann z88int.txt nicht oeffnen...Stop!\n";
    open ELP, "< z88elp.txt"
    or die "kann z88elp.txt nicht oeffnen...Stop!\n";
    open I2 , "< z88i2.txt"
    or die "kann z88i2.txt nicht oeffnen...Stop!\n";
    open I5 , "< z88i5.txt"
    or die "kann z88i5.txt nicht oeffnen...Stop!\n";
    }

  if($LANG == 2)
    {
    # Eingabefiles Z88V14OS
    open I1 , "< z88i1.txt"
    or die "cannot open z88i1.txt...stop!\n";
    open MAN, "< z88man.txt"
    or die "cannot open z88man.txt...stop!\n";
    open MAT, "< z88mat.txt"
    or die "cannot open z88mat.txt...stop!\n";
    open INT, "< z88int.txt"
    or die "cannot open z88int.txt...stop!\n";
    open ELP, "< z88elp.txt"
    or die "cannot open z88elp.txt...stop!\n";
    open I2 , "< z88i2.txt"
    or die "cannot open z88i2.txt...stop!\n";
    open I5 , "< z88i5.txt"
    or die "cannot open z88i5.txt...stop!\n";
    }
  }

#=======================================================================
# Quit
#=======================================================================
if($CHOICE == 9) { goto Lquit; }

#-----------------------------------------------------------------------
# Start der Untersuchung: 1.Runde: Checken
#-----------------------------------------------------------------------
$ier= 0;

if(&G1I188 == 1) { $ier= 1; goto Lquit; } # 1.Zeile Z88I1.TXT untersuchen
if(&G2I188 == 1) { $ier= 1; goto Lquit; } # Knoten Z88I1.TXT untersuchen
if(&G3I188 == 1) { $ier= 1; goto Lquit; } # Koinzi Z88I1.TXT untersuchen

if(&GMAN88 == 1) { $ier= 1; goto Lquit; } # Z88MAN.TXT untersuchen
if(&GMAT88 == 1) { $ier= 1; goto Lquit; } # Z88MAT.TXT untersuchen
if(&GELP88 == 1) { $ier= 1; goto Lquit; } # Z88ELP.TXT untersuchen
if(&GINT88 == 1) { $ier= 1; goto Lquit; } # Z88INT.TXT untersuchen
if(&G51M88 == 1) { $ier= 1; goto Lquit; } # 51.TXT untersuchen

if(&GXI288 == 1) { $ier= 1; goto Lquit; } # Z88I2.TXT untersuchen
if(&GXI588 == 1) { $ier= 1; goto Lquit; } # Z88I5.TXT untersuchen

#-----------------------------------------------------------------------
# Ende: Schliessen aller Dateien nach der 1.Runde
#-----------------------------------------------------------------------
close I1;
close MAN;
close MAT;
close INT;
close ELP;
close I2;
close I5;

#-----------------------------------------------------------------------
# 2.Runde: Schreiben Z88Tina-Dateien
#-----------------------------------------------------------------------
print "\n***************************************************\n";
print "\n***************************************************\n";

if($LANG == 1)
  {
  print "Z88I1_TINA.TXT + Z88I2_TINA.TXT werden geschrieben\n";
  # Eingabefiles Z88V14OS
  open I1 , "< z88i1.txt"
  or die "kann z88i1.txt nicht oeffnen...Stop!\n";
  open MAN, "< z88man.txt"
  or die "kann z88man.txt nicht oeffnen...Stop!\n";
  open MAT, "< z88mat.txt"
  or die "kann z88mat.txt nicht oeffnen...Stop!\n";
  open INT, "< z88int.txt"
  or die "kann z88int.txt nicht oeffnen...Stop!\n";
  open ELP, "< z88elp.txt"
  or die "kann z88elp.txt nicht oeffnen...Stop!\n";
  open I2 , "< z88i2.txt"
  or die "kann z88i2.txt nicht oeffnen...Stop!\n";
  # Ausgabefiles Z88V13
  open O1 , "> z88i1_tina.txt"
  or die "kann z88i1_tina.txt nicht oeffnen...Stop!\n";
  open O2 , "> z88i2_tina.txt"
  or die "kann z88i2_tina.txt nicht oeffnen...Stop!\n";
  }

if($LANG == 2)
  {
  print "Z88I1_TINA.TXT + Z88I2_TINA.TXT are filed\n";
  # Eingabefiles Z88V14OS
  open I1 , "< z88i1.txt"
  or die "cannot open z88i1.txt...stop!\n";
  open MAN, "< z88man.txt"
  or die "cannot open z88man.txt...stop!\n";
  open MAT, "< z88mat.txt"
  or die "cannot open z88mat.txt...stop!\n";
  open INT, "< z88int.txt"
  or die "cannot open z88int.txt...stop!\n";
  open ELP, "< z88elp.txt"
  or die "cannot open z88elp.txt...stop!\n";
  open I2 , "< z88i2.txt"
  or die "cannot open z88i2.txt...stop!\n";
  # Ausgabefiles Z88V13
  open O1 , "> z88i1_tina.txt"
  or die "cannot open z88i1_tina.txt...Stop!\n";
  open O2 , "> z88i2_tina.txt"
  or die "cannot open z88i2_tina.txt...Stop!\n";
  }

&WAUX88;  # Zusammenstellen der Materialgesetze
&WI188;   # Z88I1.TXT schreiben
&WI288;   # Z88I2.TXT schreiben

close I1;
close MAN;
close MAT;
close INT;
close ELP;
close I2;
close O1;
close O2;

print "\n***************************************************\n";

#-----------------------------------------------------------------------
# das war Ihr Leben
#-----------------------------------------------------------------------

Lquit:;
if($ier == 0)
  {
  if($LANG == 1) 
    { 
    print "alle Checks absolviert - keine Fehler entdeckt.\n";
    print "Z88Tina-Dateien geschrieben.\n";
    }
  if($LANG == 2) 
    { 
    print "all checks done - no errors detected.\n";
    print "Z88Tina files written.\n" 
    }
  }
else
  {
  if($LANG == 1) { print "Checks teilweise absolviert - Fehler entdeckt!\n" }
  if($LANG == 2) { print "checks partly done - errors detected!\n" }
  }

}# Ende Hauptprogramm

#***********************************************************************
# ab hier die Funktionen der 2:Runde: Auschreiben fuer Z88Tina
#***********************************************************************


#***********************************************************************
# WAUX88: die Z88V13-Materialzeilen komponieren
#***********************************************************************
sub WAUX88 
{

#-----------------------------------------------------------------------
# einen Vektor @svector aufbauen, der alle $ibis enthaelt
#-----------------------------------------------------------------------
# MAT
for($j= 1;$j <= $mmat; $j++) {
  push @svector, $ibis_mat[$j];
  }

# ELP
for($j= 1;$j <= $melp; $j++) {
  push @svector, $ibis_elp_a[$j];
  }

# INT
for($j= 1;$j <= $mint; $j++) {
  push @svector, $ibis_int_a[$j];
  }

# I5
for($j= 1;$j <= $mnpr; $j++) {
  push @svector, $ibis_i5[$j];
  }

#-----------------------------------------------------------------------
# Sortieren von @svector
#-----------------------------------------------------------------------
sub zahl { $a <=> $b }
@rf1= sort zahl @svector;

#print "Hugo @rf1\n";

#-----------------------------------------------------------------------
# mehrfache Eintraege ausfiltern
#-----------------------------------------------------------------------
$rf_alt= 0;
foreach $rf (@rf1)
  {
  if($rf != $rf_alt) 
    {
    push @grf, $rf;
    $rf_alt= $rf;
    }
  }

#print "Harry @grf\n";

$lae_grf= @grf;

$ivon_neu[1]= 1;
for($j= 1; $j <= $lae_grf; $j++)
  {
  $ibis_neu[$j]= shift @grf;
  $ivon_neu[$j+1] = $ibis_neu[$j]+1;
  #print "J:$j  IVON $ivon_neu[$j]  IBIS $ibis_neu[$j]\n";
  }

$neg= $lae_grf;
}

#***********************************************************************
# WI188: Schreiben Z88I1.TXT
#***********************************************************************
sub WI188 
{
$iqflag= 0; 

#-----------------------------------------------------------------------
# erste Zeile Z88I1.TXT
#-----------------------------------------------------------------------
$zeile = <I1>;  # leerlesen, die Originalzeile wird nicht verwendet

printf O1 "%4d %4d %4d %4d %4d %4d %4d %4d %4d\n",
  $ndim,$nkp,$ne,$nfg,$neg,$kflag,$ibflag,$ipflag,$iqflag;

#-----------------------------------------------------------------------
# Koordinaten Z88I1.TXT
#-----------------------------------------------------------------------
for($j= 1;$j <= $nkp; $j++)
  {
  $zeile = <I1>;
  print O1 $zeile;
  }

#-----------------------------------------------------------------------
# Koinzidenz Z88I1.TXT
#-----------------------------------------------------------------------
for($j= 1;$j <= $ne; $j++)
  {
  $zeile = <I1>;
  print O1 $zeile;
  $zeile = <I1>;
  print O1 $zeile;
  }

#-----------------------------------------------------------------------
# Materialgesetze Z88I1.TXT
#-----------------------------------------------------------------------
for($j= 1; $j <= $neg; $j++)
  {
  # MAT ausfiltern
  for($i= 1; $i <= $mmat; $i++)
    {
    if($ivon_mat[$i] <= $ivon_neu[$j] && $ibis_mat[$i] >= $ibis_neu[$j])
       {
       $emod_neu[$j]= $emod[$i];
       $rnue_neu[$j]= $rnue[$i];
       last;
       }
    }
  # ELP ausfiltern
  for($i= 1; $i <= $melp; $i++)
    {
    if($ivon_elp_a[$i] <= $ivon_neu[$j] && $ibis_elp_a[$i] >= $ibis_neu[$j])
       {
       $qpara_neu[$j]= $qpara_a[$i];
       $riyy_neu[$j] = $riyy_a[$i];
       $eyy_neu[$j]  = $eyy_a[$i];
       $rizz_neu[$j] = $rizz_a[$i];
       $ezz_neu[$j]  = $ezz_a[$i];
       $rit_neu[$j]  = $rit_a[$i];
       $wt_neu[$j]   = $wt_a[$i];
       last;
       }
    }  
  # INT ausfiltern    
  for($i= 1; $i <= $mint; $i++)
    {
    if($ivon_int_a[$i] <= $ivon_neu[$j] && $ibis_int_a[$i] >= $ibis_neu[$j])
       {
       $intord_neu[$j]= $intord_a[$i];
       last;
       }
    }
  # I5 ausfiltern
  if($ipflag == 1 && $ibflag == 0) # der Sonderfall Platte 18
    {
    for($i= 1; $i <= $mnpr; $i++)
      {
      if($ivon_i5[$i] <= $ivon_neu[$j] && $ibis_i5[$i] >= $ibis_neu[$j])
        {
        $riyy_neu[$j]= $flal_i5[$i]; # die Flaechenlast auf RIYY geben
        last;
        }
      }
    }

  printf O1 "%4g %4g %8g %4g %2g %8g %8g %8g %8g %8g %8g %8g\n",
  $ivon_neu[$j],$ibis_neu[$j],$emod_neu[$j],$rnue_neu[$j],$intord_neu[$j],
  $qpara_neu[$j],$riyy_neu[$j],$eyy_neu[$j],$rizz_neu[$j],$ezz_neu[$j],$rit_neu[$j],$wt_neu[$j];
  }
}  # Ende Function

#***********************************************************************
# WI288: Schreiben Z88I2.TXT
#***********************************************************************
sub WI288 
{
for($j= 1;$j <= $nrb+1; $j++)
  {
  $zeile = <I2>;
  print O2 $zeile;
  }
}

#***********************************************************************
# G1I188: erste Zeile Z88I1.TXT checken
#***********************************************************************
sub G1I188 {

print "\n***************************************************\n";

if($LANG == 1) { print "untersuche 1.Zeile von z88i1.txt\n"; }
if($LANG == 2) { print "investigating 1st line of z88i1.txt\n"; }

chomp($zeile = <I1>);
@ts= split " ",$zeile;

$jcou= 4; # Z88I1.TXT --> 5 Eintraege

for($i= 0; $i <= $jcou;$i++)
  {
  if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
    {
    if($LANG == 1) { print "Schreibfehler in 1.Zeile entdeckt...Stop\n"; }
    if($LANG == 2) { print "typing error in 1st line detected...stop\n"; }
    return 1;
    }
  }

$ndim = $ts[0];
$nkp  = $ts[1];
$ne   = $ts[2];
$nfg  = $ts[3];
$kflag= $ts[4];

if($LANG == 1) { print "Dimension $ndim entdeckt\n"; }
if($LANG == 2) { print "dimension $ndim detected\n"; }
if($LANG == 1) { print "$nkp Knoten entdeckt\n"; }
if($LANG == 2) { print "$nkp nodes detected\n"; }
if($LANG == 1) { print "$ne Elemente entdeckt\n"; }
if($LANG == 2) { print "$ne elements detected\n"; }
if($LANG == 1) { print "$nfg Freiheitsgrade entdeckt\n"; }
if($LANG == 2) { print "$nfg degrees of freedom detected\n"; }

if($kflag == 1)
  {
  if($LANG == 1) { print "Radial- bzw. Zylinderkoordinaten fuer finite E. entdeckt\n"; }
  if($LANG == 2) { print "radial or cylinder coordinates for finite ele. detected\n"; }
  }
if($kflag == 0)
  {
  if($LANG == 1) { print "kartesische Koordinaten fuer finite E. entdeckt\n"; }
  if($LANG == 2) { print "cartesian coordinates for finite ele. detected\n"; }
  }

if(!($ndim == 2 || $ndim == 3))
  {
  if($LANG == 1) { print "Dimension ndim in 1.Zeile falsch...Stop\n"; }
  if($LANG == 2) { print "dimension ndim wrong in 1st line...stop\n"; }
  return 1;
  }

if($nkp <= 0)
  {
  if($LANG == 1) { print "Anzahl Knoten nkp in 1.Zeile <= 0...Stop\n"; }
  if($LANG == 2) { print "number of nodes nkp <= 0 in 1st line...stop\n"; }
  return 1;
  }

if($ne <= 0)
  {
  if($LANG == 1) { print "Anzahl Elemente ne in 1.Zeile <= 0...Stop\n"; }
  if($LANG == 2) { print "number of elements ne <= 0 in 1st line...stop\n"; }
  return 1;
  }

if(($ndim == 2 && $nfg < 2*$nkp) || ($ndim == 3 && $nfg < 3*$nkp)) # recht grob
  {
  if($LANG == 1) { print "Anzahl Freiheitsgrade nfg in 1.Zeile zu klein...Stop\n"; }
  if($LANG == 2) { print "too few DOF = nfg in 1st line...stop\n"; }
  return 1;
  }

if(!($kflag == 0 || $kflag == 1))
  {
  if($LANG == 1) { print "Koordinatenflag kflag in 1.Zeile falsch...Stop\n"; }
  if($LANG == 2) { print "coordinate flag kflag wrong in 1st line...stop\n"; }
  return 1;
  }

return 0;
}

#***********************************************************************
# G2I188: zweite Gruppe = Knoteninfos von Z88I1.TXT checken
#***********************************************************************
sub G2I188 {

if($LANG == 1) { print "untersuche Knoteninfos von z88i1.txt\n"; }
if($LANG == 2) { print "investigating nodal infos of z88i1.txt\n"; }

$sfrei= 0;

for($j= 1;$j <= $nkp; $j++)
  {
  chomp($zeile = <I1>);
  @ts= split " ",$zeile;

  if($ndim == 2) { $ibis= 3; }
  if($ndim == 3) { $ibis= 4; }

  $n= $j+1; # wg. Zeile 1

  for($i= 0; $i <= $ibis;$i++)
    {
    if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  $iknot    = $ts[0];
  $ifrei[$j]= $ts[1];

  $sfrei += $ifrei[$j];

  if($iknot != $j)
    {
    if($LANG == 1) { print "Zeile $n: Knotennummer stimmt nicht...Stop\n"; }
    if($LANG == 2) { print "line $n: nodal number wrong...stop\n"; }
    return 1;
    }

  if(!($ifrei[$j] == 2 || $ifrei[$j] == 3 || $ifrei[$j] == 6))
    {
    if($LANG == 1) { print "Zeile $n: Anzahl FG stimmt nicht...Stop\n"; }
    if($LANG == 2) { print "line $n: number of DOF wrong...stop\n"; }
    return 1;
    }
  }

if($sfrei != $nfg)
  {
  if($LANG == 1) { print "Summe FG stimmt nicht, vgl. Zeile 1...Stop\n"; }
  if($LANG == 2) { print "sum of DOF wrong, see line 1...stop\n"; }
  return 1;
  }

if($LANG == 1) { print "Knoteninfos koennten okay sein\n"; }
if($LANG == 2) { print "nodal infos may be okay\n"; }

return 0;
}

#***********************************************************************
# G3I188: dritte Gruppe = Koinzidenz von Z88I1.TXT checken
#***********************************************************************
sub G3I188 {

if($LANG == 1) { print "untersuche Elementinfos von z88i1.txt\n"; }
if($LANG == 2) { print "investigating element infos of z88i1.txt\n"; }

$n= 1+$nkp; # wg. Zeile 1 und Knoteninfos

for($j= 1;$j <= $ne; $j++)
  {
#-----------------------------------------------------------------------
# erste Zeile fuer Elementinfo
#-----------------------------------------------------------------------
  chomp($zeile1 = <I1>);
  @ts1= split " ",$zeile1;

  $n++;

  for($i= 0; $i <= 1;$i++)
    {
    if($ts1[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  $iele= $ts1[0];
  $ityp= $ts1[1];

  $jtyp[$j]= $ityp;  # sichern, aber mit $ityp weiterarbeiten (schneller)

  if($iele != $j)
    {
    if($LANG == 1) { print "Zeile $n: Elementnummer stimmt nicht...Stop\n"; }
    if($LANG == 2) { print "line $n: element number wrong...stop\n"; }
    return 1;
    }

  if(!($ityp >= 1 && $ityp <= 24))
    {
    if($LANG == 1) { print "Zeile $n: Elementtyp existiert nicht...Stop\n"; }
    if($LANG == 2) { print "line $n: element type does not exist...stop\n"; }
    return 1;
    }

  if($ndim == 2 && 
     !($ityp ==  3 || $ityp ==  6 || $ityp ==  7 || $ityp == 8  ||
       $ityp ==  9 || $ityp == 11 || $ityp == 12 || $ityp == 13 ||
       $ityp == 14 || $ityp == 15 || $ityp == 18 || $ityp == 19 ||
       $ityp == 20))
    {
    if($LANG == 1) { print "Zeile $n: Elementtyp passt nicht zu ndim=2...Stop\n"; }
    if($LANG == 2) { print "line $n: element type does not work with ndim=2...stop\n"; }
    return 1;
    }

  if($ndim == 3 && 
     !($ityp ==  1 || $ityp ==  2 || $ityp ==  4 || $ityp == 5  ||
       $ityp == 10 || $ityp == 16 || $ityp == 17 || $ityp == 21 ||
       $ityp == 22 || $ityp == 23 || $ityp == 24 ))
    {
    if($LANG == 1) { print "Zeile $n: Elementtyp passt nicht zu ndim=3...Stop\n"; }
    if($LANG == 2) { print "line $n: element type does not work with ndim=3...stop\n"; }
    return 1;
    }

#-----------------------------------------------------------------------
# zweite Zeile fuer Elementinfo
#-----------------------------------------------------------------------
  chomp($zeile2 = <I1>);
  @ts2= split " ",$zeile2;

  $n++;
  $jmax= 0;

#-----------------------------------------------------------------------
# Elemente mit 2 Knoten
#-----------------------------------------------------------------------
  if($ityp == 2 || $ityp == 4 || $ityp == 5 || $ityp == 9 || $ityp == 13)
    {
    for($i= 0; $i <= 1;$i++)
      {
      if($ts2[$i]=~ /[A-DF-Za-df-z,_#;:]/)
        {
        if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
        if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
        return 1;
        }
      $koi[$i+1] = $ts2[$i];
      }
    $jmax= 2;
    }  # Ende Elemente mit 2 Knoten

#-----------------------------------------------------------------------
# Elemente mit 6 Knoten
#-----------------------------------------------------------------------
  if($ityp == 14 || $ityp == 15 || $ityp == 18)
    {
    for($i= 0; $i <= 5;$i++)
      {
      if($ts2[$i]=~ /[A-DF-Za-df-z,_#;:]/)
        {
        if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
        if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
        return 1;
        }
      $koi[$i+1] = $ts2[$i];
      }
    $jmax= 6;
    }  # Ende Elemente mit 6 Knoten

#-----------------------------------------------------------------------
# Knotennummern innerhalb logischer Grenzen ?
#----------------------------------------------------------------------- 
  for($k = 1;$k <= $jmax;$k++)
    {
    if(!($koi[$k] > 0 && $koi[$k] <= $nkp))
      {
      if($LANG == 1) { print "Knotennummer nicht 1 ~ $nkp in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "nodal number not 1 ~ $nkp in line $n detected...stop\n"; }
      return 1;
      }
    }

#-----------------------------------------------------------------------
# passen die Freiheitsgrade zum Elementtyp? Nicht sehr genau...
#----------------------------------------------------------------------- 
  for($k = 1;$k <= $jmax;$k++)
    {
    # echt nur 2 FG: Toruselemente
    if( $ityp == 15 && $ifrei[$koi[$k]] == 2) 
      { next; }
    # 2 oder 3 FG, denn Scheiben und 2D-Staebe koennen an Balken Nr.13 angeschlossen werden
    if( ($ityp ==  9 || $ityp == 13 ||$ityp == 14) && ($ifrei[$koi[$k]] == 2 || $ifrei[$koi[$k]] == 3)) 
      { next; }
    # 3 oder 6 FG, denn Volumenele. koennen an Balken Nr.2 angeschlossen werden
    if( ($ityp == 2  || $ityp ==  4 || $ityp ==  5 || $ityp == 18) &&
        ($ifrei[$koi[$k]] == 3 || $ifrei[$koi[$k]] == 6) ) 
      { next; }

    if($LANG == 1) { print "Zeile $n: FG passen nicht zum Element...Stop\n"; }
    if($LANG == 2) { print "line $n: DOF not correct for element typ...stop\n"; }
    return 1;
    }

#-----------------------------------------------------------------------
# doppelte Knotennummern ?
#----------------------------------------------------------------------- 
  for($k = 1;$k <= $jmax-1;$k++)
    {
    for($m= $k+1;$m <= $jmax;$m++)
      {
      if($koi[$k] == $koi[$m])
        {
        if($LANG == 1) { print "identische Knotennummern in Zeile $n entdeckt...Stop\n"; }
        if($LANG == 2) { print "identical nodal numbers in line $n detected...stop\n"; }
        return 1;
        }
      }
    }

  } # Ende grosse Schleife

#-----------------------------------------------------------------------
# ibflag_i1,ipflag_i1 feststellen und Elementtypen zaehlen
#----------------------------------------------------------------------- 
$ibflag_i1= 0;
$ipflag_i1= 0;

for($j= 1;$j <= 25; $j++) { $ctyp[$j]= 0; }

for($j= 1;$j <= $ne; $j++)
  {
  if($jtyp[$j] ==  2 || $jtyp[$j] == 13)                    { $ibflag_i1= 1; }
  if($jtyp[$j] == 18 || $jtyp[$j] == 19 || $jtyp[$j] == 20) { $ipflag_i1= 1; }

  $ctyp[$jtyp[$j]]++;
  }

if($LANG == 1) { print "berechnet: ibflag=$ibflag_i1, ipflag=$ipflag_i1\n"; }
if($LANG == 2) { print "computed: ibflag=$ibflag_i1, ipflag=$ipflag_i1\n"; }

for($j= 1;$j <= 24; $j++)
  {
  if($ctyp[$j] > 0)
    {
    if($LANG == 1) { print "$ctyp[$j] Elemente vom Typ $j entdeckt\n"; }
    if($LANG == 2) { print "$ctyp[$j] elements of type $j detected\n"; }
    }
  }

if($LANG == 1) { print "Elementinfos koennten okay sein\n"; }
if($LANG == 2) { print "element infos may be okay\n"; }
if($LANG == 1) { print "z88i1.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88i1.txt checked, no errors detected\n"; }

return 0;
}


#***********************************************************************
# GXI288: Z88I2.TXT checken
#***********************************************************************
sub GXI288 {

#-----------------------------------------------------------------------
# 1.Zeile Z88I2.TXT untersuchen
#----------------------------------------------------------------------- 
print "\n***************************************************\n";
if($LANG == 1) { print "untersuche 1.Zeile von z88i2.txt\n"; }
if($LANG == 2) { print "investigating 1st line of z88i2.txt\n"; }

chomp($zeile = <I2>);
@ts= split " ",$zeile;

if($ts[0]=~ /[A-DF-Za-df-z,_#;:]/)
  {
  if($LANG == 1) { print "Schreibfehler in 1.Zeile entdeckt...Stop\n"; }
  if($LANG == 2) { print "typing error in 1st line detected...stop\n"; }
  return 1;
  }

$nrb = $ts[0];

if($LANG == 1) { print "$nrb Randbedingungen entdeckt\n"; }
if($LANG == 2) { print "$nrb constraints detected\n"; }

if($nrb > $nfg)
  {
  if($LANG == 1) { print "zuviele Randbedingungen in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too many constraints in 1st line detected...stop\n"; }
  return 1;
  }

if($ndim == 2)
  {
  if($nrb < 4 && !($ctyp[15] > 0))
    {
    if($LANG == 1) { print "zuwenig RB (<4) fuer 2D in 1.Zeile endeckt...Stop\n"; }
    if($LANG == 2) { print "too few BC (<4) for 2D in 1st line detected...stop\n"; }
    return 1;
    }
  if($nrb < 2 && ($ctyp[15] > 0))
    {
    if($LANG == 1) { print "zuwenig RB (<2) fuer 2D in 1.Zeile endeckt...Stop\n"; }
    if($LANG == 2) { print "too few BC (<2) for 2D in 1st line detected...stop\n"; }
    return 1;
    }
  }

if($ndim == 3)
  {
  if($nrb < 6)
    {
    if($LANG == 1) { print "zuwenig RB (<6) fuer 3D in 1.Zeile endeckt...Stop\n"; }
    if($LANG == 2) { print "too few BC (<6) for 3D in 1st line detected...stop\n"; }
    return 1;
    }
  }

#-----------------------------------------------------------------------
# die Randbedingungen von Z88I2.TXT untersuchen
#----------------------------------------------------------------------- 
if($LANG == 1) { print "untersuche Randbedingungen von z88i2.txt\n"; }
if($LANG == 2) { print "investigating boundary conditions of z88i2.txt\n"; }

$nknalt= 0;
$ifgalt= 0;
$n= 1;
$forc= 0;
$disp= 0;

for($j= 1;$j <= $nrb; $j++)
  {
  $n++;

  chomp($zeile = <I2>);
  @ts= split " ",$zeile;

  for($i= 0; $i <= 3;$i++)
    {
    if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  if($j > 1)
    {
    $nknalt= $nkn;
    $ifgalt= $ifg;
    }

  $nkn   = $ts[0];
  $ifg   = $ts[1];
  $iflag1= $ts[2];

  if($iflag1 == 1) { $forc++; }
  if($iflag1 == 2) { $disp++; }

#=======================================================================
# logische Pruefung
#======================================================================= 
  if($nkn < 1 || $nkn > $nkp)
    {
    if($LANG == 1) { print "Knotennummer in Zeile $n ungueltig...Stop\n"; }
    if($LANG == 2) { print "nodal number in line $n out of range...stop\n"; }
    return 1;
    }

  if($j > 1)
    { 
    if($nkn < $nknalt)
      {
      if($LANG == 1) { print "Knotennummern in Zeile $n nicht aufsteigend...Stop\n"; }
      if($LANG == 2) { print "nodal number in line $n not ascending...stop\n"; }
      return 1;
      }
    }

  if($ifg < 1)
    {
    if($LANG == 1) { print "FG in Zeile $n < 1...Stop\n"; }
    if($LANG == 2) { print "DOF in line $n < 1...stop\n"; }
    return 1;
    }

  if($ifg > $ifrei[$nkn])
    {
    if($LANG == 1) { print "FG in Zeile $n > als in z88i1.txt...Stop\n"; }
    if($LANG == 2) { print "DOF in line $n > than in z88i1.txt...stop\n"; }
    return 1;
    }

  if($nkn == $nknalt)
    { 
    if($ifg <= $ifgalt)
      {
      if($LANG == 1) { print "#FG in Zeile $n nicht aufsteigend...Stop\n"; }
      if($LANG == 2) { print "#DOF in line $n not ascending...stop\n"; }
      return 1;
      }
    }

  if(!($iflag1 == 1 || $iflag1 == 2))
    {
    if($LANG == 1) { print "Steuerflag in Zeile $n nicht 1 oder 2...Stop\n"; }
    if($LANG == 2) { print "load/displacement flag in line $n not 1 or 2...stop\n"; }
    return 1;
    }
  }

if($LANG == 1) { print "$forc Kraft-RB und $disp Weg-RB entdeckt\n"; }
if($LANG == 2) { print "$forc BC/forces and $disp BC/displacements detected\n"; }

if($LANG == 1) { print "Randbedingungen koennten okay sein\n"; }
if($LANG == 2) { print "boundary conditions may be okay\n"; }

if($LANG == 1) { print "z88i2.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88i2.txt checked, no errors detected\n"; }

return 0;
}

#***********************************************************************
# GXI588: Z88I5.TXT checken
#***********************************************************************
sub GXI588 {

#-----------------------------------------------------------------------
# 1.Zeile Z88I5.TXT untersuchen
#----------------------------------------------------------------------- 
print "\n***************************************************\n";
if($LANG == 1) { print "untersuche 1.Zeile von z88i5.txt\n"; }
if($LANG == 2) { print "investigating 1st line of z88i5.txt\n"; }

chomp($zeile = <I5>);
@ts= split " ",$zeile;

if($ts[0]=~ /[A-DF-Za-df-z,_#;:]/)
  {
  if($LANG == 1) { print "Schreibfehler in 1.Zeile entdeckt...Stop\n"; }
  if($LANG == 2) { print "typing error in 1st line detected...stop\n"; }
  return 1;
  }

$mnpr= 0;
$npr = $ts[0];

if($npr > 0) # Flaechenlasten 
  {
  $ifsurf = 1;
  if($LANG == 1) { print "$npr Flaechenlasten entdeckt\n"; }
  if($LANG == 2) { print "$npr surface loads detected\n"; }
  }

if($npr == 0) # keine Flaechenlasten, also zurueck 
  {
  $ifsurf = 0;
  if($LANG == 1) { print "keine Flaechenlasten entdeckt\n"; }
  if($LANG == 2) { print "no surface loads detected\n"; }
  return 0;
  }

if($npr > $ne)
  {
  if($LANG == 1) { print "zuviele Flaechenlasten in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too many surface loads in 1st line detected...stop\n"; }
  return 1;
  }

if($npr < 0)
  {
  if($LANG == 1) { print "zuwenig Flaechenlasten in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too few surface loads in 1st line detected...stop\n"; }
  return 1;
  }

#-----------------------------------------------------------------------
# die Flaechenlasten von Z88I5.TXT untersuchen
#----------------------------------------------------------------------- 
if($LANG == 1) { print "untersuche Flaechenlasten von z88i5.txt\n"; }
if($LANG == 2) { print "investigating surface loads of z88i5.txt\n"; }

for($i= 1; $i <= $ne; $i++)  # soviel koennen's maximal sein
  {
  $pres[$i]= 0;
  }

$n= 1;

# Schleife uber alle Eintraege
for($j= 1;$j <= $npr; $j++)
  {
  $n++;

  chomp($zeile = <I5>);
  @ts= split " ",$zeile;

  for($i= 0; $i <= 1;$i++)
    {
    if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  $jele= $ts[0];
  $flal= $ts[1];

  $pres[$jele]= $flal; # jetzt ist an den fraglichen Stellen p gespeichert

#=======================================================================
# logische Pruefung
#======================================================================= 
  if($jele < 1 || $jele > $ne)
    {
    if($LANG == 1) { print "Elementnummer in Zeile $n ungueltig...Stop\n"; }
    if($LANG == 2) { print "element number in line $n out of range...stop\n"; }
    return 1;
    }

  $ityp= $jtyp[$jele];

  if($ityp == 2 || $ityp == 4 || $ityp == 5 || $ityp == 9 || $ityp == 13)
    {
    if($LANG == 1) { print "Elementtyp in Zeile $n nicht fuer Flaechenlasten geeignet...Stop\n"; }
    if($LANG == 2) { print "element type in line $n not not allowed for surface loads...stop\n"; }
    return 1;
    }


#=======================================================================
# Elementtyp 14,15
#======================================================================= 
  if($ityp == 14 || $ityp == 15)
    {
    if($LANG == 1) { print "Flächenlasten fuer Ele.14 + 15 noch nicht implementiert ...Stop\n"; }
    if($LANG == 2) { print "surface loads for ele.14 + 15 not yet implemented..stop\n"; }
    return 1;
    }

#=======================================================================
# Elementtyp 18
#======================================================================= 
  if($ityp == 18)
    {
    if($ts[1]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    $jmax= 0;
    }

  }  # Ende grosse Schleife

for($i= 1; $i <= $ne; $i++)
  {
  
#=======================================================================
# $ivon_i5 und $ibis_i5 feststellen
#=======================================================================
  if($i == 1)  # Sonderfall 1
    {
    $ivon_i5[1]= 1;
    $k= 1;
    }
  else  # von 2 bis Ende
    {
    if($pres[$i] != $pres[$i-1])
      {
      $k++;
      $ibis_i5[$k-1]= $i-1;
      $flal_i5[$k-1]= $pres[$i-1];
      $ivon_i5[$k  ]= $i;
      }
    if($i == $ne)
      {
      $ibis_i5[$k]= $ne;
      $flal_i5[$k]= $pres[$ne];
      }
    }
  } # Ende for $i

$mnpr= $k; # Anzahl E-Gesetze aufgrund Flaechenlasten

for($j = 1; $j <= $mnpr; $j++)
  {
  if($LANG == 1)
    {
    print "Nr.$j: von $ivon_i5[$j] bis $ibis_i5[$j] Faechenlast $flal_i5[$j]\n";
    }
  if($LANG == 2)
    {
    print "No.$j: from $ivon_i5[$j] to $ibis_i5[$j] surface load $flal_i5[$j]\n";
    }

  }

if($LANG == 1) { print "Flaechenlasten koennten okay sein\n"; }
if($LANG == 2) { print "surface loads may be okay\n"; }

if($LANG == 1) { print "z88i5.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88i5.txt checked, no errors detected\n"; }

return 0;
}

#***********************************************************************
# GMAN88: Z88MAN.TXT checken
#***********************************************************************
sub GMAN88 {

print "\n***************************************************\n";
if($LANG == 1) { print "untersuche z88man.txt\n"; }
if($LANG == 2) { print "investigating z88man.txt\n"; }

while ($zeile = <MAN>)
  {
  chomp($zeile);  # chomp erst hier, nicht im while wg. -w
  @ts= split " ",$zeile;
  if(@ts == 0) { next; } # wg. -w

#-----------------------------------------------------------------------
# IBFLAG?
#----------------------------------------------------------------------- 
  if($ts[0] eq "IBFLAG")
    {
    $ibflag= $ts[1];
    print "IBFLAG=$ibflag\n";

    if(($ibflag != $ibflag_i1) && $ibflag_i1 == 1)
      {
      if($LANG == 1) { print "IBFLAG falsch, es wurden Balken in z88i1.txt entdeckt...Stop\n"; }
      if($LANG == 2) { print "IBFLAG wrong, beams were detected in z88i1.txt...stop\n"; }
      return 1;
      }
    if(($ibflag != $ibflag_i1) && $ibflag_i1 == 0)
      {
      if($LANG == 1) { print "IBFLAG falsch, es wurden keine Balken in z88i1.txt entdeckt...Stop\n"; }
      if($LANG == 2) { print "IBFLAG wrong, no beams were detected in z88i1.txt...stop\n"; }
      return 1;
      }
    }

#-----------------------------------------------------------------------
# IPFLAG?
#----------------------------------------------------------------------- 
  if($ts[0] eq "IPFLAG")
    {
    $ipflag= $ts[1];
    print "IPFLAG=$ipflag\n";

    if($ipflag >= 1) { $ipflag= 1; }  # ipflag kann 0,1,2,2,3,4 sein

    if(($ipflag != $ipflag_i1) && $ipflag_i1 == 1)
      {
      if($LANG == 1) { print "IPFLAG falsch, es wurden Platten in z88i1.txt entdeckt...Stop\n"; }
      if($LANG == 2) { print "IPFLAG wrong, plates were detected in z88i1.txt...stop\n"; }
      return 1;
      }
    if(($ipflag != $ipflag_i1) && $ipflag_i1 == 0)
      {
      if($LANG == 1) { print "IPFLAG falsch, es wurden keine Platten in z88i1.txt entdeckt...Stop\n"; }
      if($LANG == 2) { print "IPFLAG wrong, no plates were detected in z88i1.txt...stop\n"; }
      return 1;
      }
    }

  } # end while

if($LANG == 1) { print "z88man.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88man.txt checked, no errors detected\n"; }

return 0;
}

#***********************************************************************
# GMAT88: Z88MAT.TXT checken
#***********************************************************************
sub GMAT88 {

#-----------------------------------------------------------------------
# 1.Zeile Z88MAT.TXT untersuchen
#----------------------------------------------------------------------- 
print "\n***************************************************\n";
if($LANG == 1) { print "untersuche 1.Zeile von z88mat.txt\n"; }
if($LANG == 2) { print "investigating 1st line of z88mat.txt\n"; }

chomp($zeile = <MAT>);
@ts= split " ",$zeile;

if($ts[0]=~ /[A-DF-Za-df-z,_#;:]/)
  {
  if($LANG == 1) { print "Schreibfehler in 1.Zeile entdeckt...Stop\n"; }
  if($LANG == 2) { print "typing error in 1st line detected...stop\n"; }
  return 1;
  }

$mmat = $ts[0];

if($LANG == 1) { print "$mmat Material-Gruppen entdeckt\n"; }
if($LANG == 2) { print "$mmat material groups detected\n"; }

if($mmat > $ne)
  {
  if($LANG == 1) { print "zuviele Materialien in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too many materials in 1st line detected...stop\n"; }
  return 1;
  }

if($mmat < 1)
  {
  if($LANG == 1) { print "zuwenig Materialien in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too few materials in 1st line detected...stop\n"; }
  return 1;
  }

#-----------------------------------------------------------------------
# die Materialzeilen von Z88MAT.TXT untersuchen
#----------------------------------------------------------------------- 
if($LANG == 1) { print "untersuche Materialgruppen von z88mat.txt\n"; }
if($LANG == 2) { print "investigating material groups of z88mat.txt\n"; }

$n= 1;
$ibisalt= 0;
$ibis= 0;

for($j= 1;$j <= $mmat; $j++)
  {
  $n++;
  
  if($j > 1) { $ibisalt= $ibis; }

  chomp($zeile = <MAT>);
  @ts= split " ",$zeile;

  for($i= 0; $i <= 1;$i++)  # nur ivon und ibis checken
    {
    if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  $ivon= $ts[0];
  $ibis= $ts[1];
  $ccsv= $ts[2];

  if($LANG == 1) { print "Materialgruppe $j: von $ivon bis $ibis mit $ccsv\n"; }
  if($LANG == 2) { print "material group $j: from $ivon to $ibis using $ccsv\n"; }

#=======================================================================
# ivon?
#=======================================================================
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sonderfall 1. E-Gesetz:
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j == 1)
    {
    if($ivon != 1)
      {
      if($LANG == 1) { print "Startwert 1.E-Gesetz in Zeile $n nicht 1...Stop\n"; }
      if($LANG == 2) { print "start value 1st mat group in line $n not 1...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ivon groesser als ibis?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($ivon > $ibis)
    {
    if($LANG == 1) { print "Anfangswert in Zeile $n groesser als Endwert...Stop\n"; }
    if($LANG == 2) { print "start value in line $n bigger than end value...stop\n"; }
    return 1;
    }

#=======================================================================
# ibis?
#=======================================================================
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ibis groesser als ne?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($ibis > $ne)
    {
    if($LANG == 1) { print "Endwert in Zeile $n groesser als Anzahl Elemente entdeckt...Stop\n"; }
    if($LANG == 2) { print "end value in line $n bigger than no. of elements detected...stop\n"; }
    return 1;
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# j > 1: ivon nicht ibisalt +1 ?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j > 1)
    {
    if($ivon != $ibisalt+1)
      {
      $n1= $n-1;
      if($LANG == 1) { print "Endwert in Zeile $n1 nicht Anfangswert-1 der Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "end value in line $n1 not (start value-1) of line $n detected...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sonderfall letztes E-Gesetz:
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j == $mmat)
    {
    if($ibis != $ne)
      {
      if($LANG == 1) { print "Endwert in Zeile $n nicht Anzahl Elemente entdeckt...Stop\n"; }
      if($LANG == 2) { print "end value in line $n not no. of elements detected...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Werte in Arrays speichern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  $ivon_mat[$j]= $ivon;
  $ibis_mat[$j]= $ibis;
  $ccsv_mat[$j]= $ccsv;
  }  # end for

if($LANG == 1) { print "Materialgruppen koennten okay sein\n"; }
if($LANG == 2) { print "material groups may be okay\n"; }

if($LANG == 1) { print "z88mat.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88mat.txt checked, no errors detected\n"; }

return 0;
}

#***********************************************************************
# GELP88: Z88ELP.TXT checken
#***********************************************************************
sub GELP88 {

#-----------------------------------------------------------------------
# 1.Zeile Z88ELP.TXT untersuchen
#----------------------------------------------------------------------- 
print "\n***************************************************\n";
if($LANG == 1) { print "untersuche 1.Zeile von z88elp.txt\n"; }
if($LANG == 2) { print "investigating 1st line of z88elp.txt\n"; }

chomp($zeile = <ELP>);
@ts= split " ",$zeile;

if($ts[0]=~ /[A-DF-Za-df-z,_#;:]/)
  {
  if($LANG == 1) { print "Schreibfehler in 1.Zeile entdeckt...Stop\n"; }
  if($LANG == 2) { print "typing error in 1st line detected...stop\n"; }
  return 1;
  }

$melp = $ts[0];

if($LANG == 1) { print "$melp Elementparameter-Gruppen entdeckt\n"; }
if($LANG == 2) { print "$melp element parameter groups detected\n"; }

if($melp > $ne)
  {
  if($LANG == 1) { print "zuviele Elementparameter-Gruppen in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too many element parameter groups in 1st line detected...stop\n"; }
  return 1;
  }

if($melp < 1)
  {
  if($LANG == 1) { print "zuwenig Elementparameter-Gruppen in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too few element parameter groups in 1st line detected...stop\n"; }
  return 1;
  }

#-----------------------------------------------------------------------
# die Elementparameter-Gruppen von Z88ELP.TXT untersuchen
#----------------------------------------------------------------------- 
if($LANG == 1) { print "untersuche Elementparameter-Gruppen von z88elp.txt\n"; }
if($LANG == 2) { print "investigating element parameter groups of z88elp.txt\n"; }

$n= 1;
$ibisalt_elp= 0;
$ibis_elp= 0;

for($j= 1;$j <= $melp; $j++)
  {
  $n++;
  
  if($j > 1) { $ibisalt_elp= $ibis_elp; }

  chomp($zeile = <ELP>);
  @ts= split " ",$zeile;

  for($i= 0; $i <= 8;$i++) 
    {
    if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  $ivon_elp= $ts[0];
  $ibis_elp= $ts[1];
  $qpara   = $ts[2];
  $riyy    = $ts[3];
  $eyy     = $ts[4];
  $rizz    = $ts[5];
  $ezz     = $ts[6];
  $rit     = $ts[7];
  $wt      = $ts[8];

  if($LANG == 1) { print "Elementparameter-Gruppe $j: von $ivon_elp bis $ibis_elp\n"; }
  if($LANG == 2) { print "element parameter group $j: from $ivon_elp to $ibis_elp\n"; }

#=======================================================================
# Parameter-Tests
#=======================================================================
  for($i= $ivon_elp;$i <= $ibis_elp;$i++)
    {
    $ityp= $jtyp[$i];

    if(($ityp ==  2 || $ityp ==  4 || $ityp ==  5 ||
        $ityp ==  9 || $ityp == 13 ||
        $ityp == 14 || $ityp == 18 ) && $qpara <= 0)
      {
      if($LANG == 1) { print "falsches qpara (3.Wert) in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "wrong qpara (3rd entry) in line $n detected...stop\n"; }
      return 1;
      }

    if($ityp ==  2 && ($riyy <= 0 || $eyy <= 0 || $rizz <= 0 ||
                       $ezz <= 0 || $rit <= 0 || $wt <= 0))
      {
      if($LANG == 1) { print "Balkenparameter fuer Element-Typ 2 in Zeile $n falsch...Stop\n"; }
      if($LANG == 2) { print "beam parameter for element type 2 in line $n wrong...stop\n"; }
      return 1;
      }

    if($ityp ==  13 && ($riyy != 0 || $eyy != 0 || $rizz <= 0 ||
                       $ezz <= 0 || $rit != 0 || $wt != 0))
      {
      if($LANG == 1) { print "Balkenparameter fuer Element-Typ 13 in Zeile $n falsch...Stop\n"; }
      if($LANG == 2) { print "beam parameter for element type 13 in line $n wrong...stop\n"; }
      return 1;
      }

    } # end for i

#=======================================================================
# ivon_elp?
#=======================================================================
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sonderfall 1. Elementparameter-Zeile:
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j == 1)
    {
    if($ivon_elp != 1)
      {
      if($LANG == 1) { print "Startwert 1.EP-Gruppe in Zeile $n nicht 1...Stop\n"; }
      if($LANG == 2) { print "start value 1st ep-group in line $n not 1...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ivon_elp groesser als ibis_elp?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($ivon_elp > $ibis_elp)
    {
    if($LANG == 1) { print "Anfangswert in Zeile $n groesser als Endwert...Stop\n"; }
    if($LANG == 2) { print "start value in line $n bigger than end value...stop\n"; }
    return 1;
    }

#=======================================================================
# ibis_elp?
#=======================================================================
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ibis_elp groesser als ne?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($ibis_elp > $ne)
    {
    if($LANG == 1) { print "Endwert in Zeile $n groesser als Anzahl Elemente entdeckt...Stop\n"; }
    if($LANG == 2) { print "end value in line $n bigger than no. of elements detected...stop\n"; }
    return 1;
    }


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# j > 1: ivon_elp nicht ibisalt_elp +1 ?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j > 1)
    {
    if($ivon_elp != $ibisalt_elp+1)
      {
      $n1= $n-1;
      if($LANG == 1) { print "Endwert in Zeile $n1 nicht Anfangswert-1 der Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "end value in line $n1 not (start value-1) of line $n detected...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sonderfall letzte Elementparameter-Gruppe:
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j == $melp)
    {
    if($ibis_elp != $ne)
      {
      if($LANG == 1) { print "Endwert in Zeile $n nicht Anzahl Elemente entdeckt...Stop\n"; }
      if($LANG == 2) { print "end value in line $n not no. of elements detected...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Werte in Arrays speichern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  $ivon_elp_a[$j]= $ivon_elp;
  $ibis_elp_a[$j]= $ibis_elp;
  $qpara_a[$j]= $qpara;
  $riyy_a[$j]= $riyy;
  $eyy_a[$j]= $eyy;
  $rizz_a[$j]= $rizz;
  $ezz_a[$j]= $ezz;
  $rit_a[$j]= $rit;
  $wt_a[$j]= $wt;
  } # end for j

if($LANG == 1) { print "Elementparameter-Gruppen koennten okay sein\n"; }
if($LANG == 2) { print "element parameter groups may be okay\n"; }

if($LANG == 1) { print "z88elp.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88elp.txt checked, no errors detected\n"; }

return 0;
}

#***********************************************************************
# GINT88: Z88INT.TXT checken
#***********************************************************************
sub GINT88 {

#-----------------------------------------------------------------------
# 1.Zeile Z88INT.TXT untersuchen
#----------------------------------------------------------------------- 
print "\n***************************************************\n";
if($LANG == 1) { print "untersuche 1.Zeile von z88int.txt\n"; }
if($LANG == 2) { print "investigating 1st line of z88int.txt\n"; }

chomp($zeile = <INT>);
@ts= split " ",$zeile;

if($ts[0]=~ /[A-DF-Za-df-z,_#;:]/)
  {
  if($LANG == 1) { print "Schreibfehler in 1.Zeile entdeckt...Stop\n"; }
  if($LANG == 2) { print "typing error in 1st line detected...stop\n"; }
  return 1;
  }

$mint = $ts[0];

if($LANG == 1) { print "$mint Integrationsordnungs-Gruppen entdeckt\n"; }
if($LANG == 2) { print "$mint integration order groups detected\n"; }

if($mint > $ne)
  {
  if($LANG == 1) { print "zuviele Integrationsordnungs-Gruppen in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too many integration order groups in 1st line detected...stop\n"; }
  return 1;
  }

if($mint < 1)
  {
  if($LANG == 1) { print "zuwenig Integrationsordnungs-Gruppen in 1.Zeile endeckt...Stop\n"; }
  if($LANG == 2) { print "too few integration order groups in 1st line detected...stop\n"; }
  return 1;
  }

#-----------------------------------------------------------------------
# die Integrationsordnungs-Gruppen von Z88INT.TXT untersuchen
#----------------------------------------------------------------------- 
if($LANG == 1) { print "untersuche Integrationsordnungs-Gruppen von z88int.txt\n"; }
if($LANG == 2) { print "investigating integration order groups of z88int.txt\n"; }

$n= 1;
$ibisalt_int= 0;
$ibis_int= 0;

for($j= 1;$j <= $mint; $j++)
  {
  $n++;
  
  if($j > 1) { $ibisalt_int= $ibis_int; }

  chomp($zeile = <INT>);
  @ts= split " ",$zeile;

  for($i= 0; $i <= 3;$i++) 
    {
    if($ts[$i]=~ /[A-DF-Za-df-z,_#;:]/)
      {
      if($LANG == 1) { print "Schreibfehler in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "typing error in line $n detected...stop\n"; }
      return 1;
      }
    }

  $ivon_int= $ts[0];
  $ibis_int= $ts[1];
  $intord  = $ts[2];
  # $intos   = $ts[3]; # wird nicht gebraucht

  if($LANG == 1) { print "Integrationsordnungs-Gruppe $j: von $ivon_int bis $ibis_int\n"; }
  if($LANG == 2) { print "integration order group $j: from $ivon_int to $ibis_int\n"; }

#=======================================================================
# Parameter-Tests
#=======================================================================
  for($i= $ivon_int;$i <= $ibis_int;$i++)
    {
    $ityp= $jtyp[$i];

    if(($ityp == 14 || $ityp == 15 || $ityp == 18) && 
      !($intord == 3 || $intord == 7 || $intord == 13) )
      {
      if($LANG == 1) { print "falsches intord (3.Wert) fuer Ele-Typ $ityp in Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "wrong intord (3rd entry) for ele type $ityp in line $n detected...stop\n"; }
      return 1;
      }

    } # end for i

#=======================================================================
# ivon_int?
#=======================================================================
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sonderfall 1. Integrationsordnungs-Zeile:
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j == 1)
    {
    if($ivon_int != 1)
      {
      if($LANG == 1) { print "Startwert 1.IO-Gruppe in Zeile $n nicht 1...Stop\n"; }
      if($LANG == 2) { print "start value 1st io-group in line $n not 1...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ivon_int groesser als ibis_int?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($ivon_int > $ibis_int)
    {
    if($LANG == 1) { print "Anfangswert in Zeile $n groesser als Endwert...Stop\n"; }
    if($LANG == 2) { print "start value in line $n bigger than end value...stop\n"; }
    return 1;
    }

#=======================================================================
# ibis_int?
#=======================================================================
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ibis_int groesser als ne?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($ibis_int > $ne)
    {
    if($LANG == 1) { print "Endwert in Zeile $n groesser als Anzahl Elemente entdeckt...Stop\n"; }
    if($LANG == 2) { print "end value in line $n bigger than no. of elements detected...stop\n"; }
    return 1;
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# j > 1: ivon_int nicht ibisalt_int +1 ?
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j > 1)
    {
    if($ivon_int != $ibisalt_int+1)
      {
      $n1= $n-1;
      if($LANG == 1) { print "Endwert in Zeile $n1 nicht Anfangswert-1 der Zeile $n entdeckt...Stop\n"; }
      if($LANG == 2) { print "end value in line $n1 not (start value-1) of line $n detected...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sonderfall letzte Gruppe:
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if($j == $mint)
    {
    if($ibis_int != $ne)
      {
      if($LANG == 1) { print "Endwert in Zeile $n nicht Anzahl Elemente entdeckt...Stop\n"; }
      if($LANG == 2) { print "end value in line $n not no. of elements detected...stop\n"; }
      return 1;
      }
    }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Werte in Arrays geben
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  $ivon_int_a[$j]= $ivon_int;
  $ibis_int_a[$j]= $ibis_int;
  $intord_a[$j]  = $intord;
  } # end for j

if($LANG == 1) { print "Integrationsordnungs-Gruppen koennten okay sein\n"; }
if($LANG == 2) { print "integration order groups may be okay\n"; }

if($LANG == 1) { print "z88int.txt gecheckt, keine Fehler entdeckt\n"; }
if($LANG == 2) { print "z88int.txt checked, no errors detected\n"; }

return 0;
}

#***********************************************************************
# G51M88: 51.TXT auslesen
#***********************************************************************
sub G51M88 {

for($j= 1;$j <= $mmat; $j++)
  {
  open M51, "< $ccsv_mat[$j]" or die "cannot open $ccsv_mat[$j]...stop!\n";

  chomp($zeile = <M51>);
  @ts= split " ",$zeile;

  $emod[$j]= $ts[0];
  $rnue[$j]= $ts[1];

  close M51;
  }

return 0;
}




